﻿using UnityEngine;

public class HideOnPlatform : MonoBehaviour
{
    public bool HideOnStandaloneWindows = false;
    public bool HideOnStandaloneMac = false;
    public bool HideOnStandaloneLinux = false;
    public bool HideOnWebGL = false;

    void Awake()
    {
        if (HideOnStandaloneWindows && Application.platform == RuntimePlatform.WindowsPlayer)
            gameObject.SetActive(false);
        
        if (HideOnStandaloneMac && Application.platform == RuntimePlatform.OSXPlayer)
            gameObject.SetActive(false);
        
        if (HideOnStandaloneLinux && Application.platform == RuntimePlatform.LinuxPlayer)
            gameObject.SetActive(false);
        
        if (HideOnWebGL && Application.platform == RuntimePlatform.WebGLPlayer)
            gameObject.SetActive(false);
    }
}
