﻿Shader "GGJ16/GfxTest"
{
	Properties
	{
		_MainTex ("Texture", 2D) = "white" {}
		_MaskTex ("Mask", 2D) = "white" {}
		_energy ("Energy", float) = 0
	}
	SubShader
	{
		Tags { "RenderType"="Opaque" }
		LOD 100

		Pass
		{
			CGPROGRAM
			#pragma vertex vert
			#pragma fragment frag
			// make fog work
			//#pragma multi_compile_fog
			
			#include "UnityCG.cginc"

			struct appdata
			{
				float4 vertex : POSITION;
				float2 uv : TEXCOORD0;
			};

			struct v2f
			{
				float2 uv : TEXCOORD0;
			//	UNITY_FOG_COORDS(1)
				float4 vertex : SV_POSITION;
			};

			sampler2D _MainTex;
			sampler2D _MaskTex;
			float4 _MainTex_ST;
			float _energy;
			
			v2f vert (appdata v)
			{
				v2f o;
				o.vertex = mul(UNITY_MATRIX_MVP, v.vertex);
				o.uv = TRANSFORM_TEX(v.uv, _MainTex);
				//UNITY_TRANSFER_FOG(o,o.vertex);
				return o;
			}
			
			fixed4 frag (v2f i) : SV_Target
			{
				// sample the texture
				fixed4 col = tex2D(_MainTex, i.uv);
				fixed4 msk = tex2D(_MaskTex, i.uv);

clip( col.a - 0.5 );

			//	float energy = saturate(frac((-_Time.y)*0.1)*1.2-0.1);
			//	energy = saturate( energy - saturate(sin(energy*3.14159*20))*0.03 );
			//	energy = 1-saturate((1-energy)*3);
				float energy = _energy;

			//	float mask = energy < msk.r ? 1.0 : 0.0;
				float mask = saturate( (msk.r - energy)*10 );

				col.rgb = lerp( dot(col.rgb,1/3.0).xxx, col.rgb, mask );
				// apply fog
				//UNITY_APPLY_FOG(i.fogCoord, col);
				return col;
			}
			ENDCG
		}
	}
}
