Shader "Sprites/GGJ_Background"
{
	Properties
	{
		[PerRendererData] _MainTex ("Color", 2D) = "white" {}
		 _Main2Tex ("Color2", 2D) = "white" {}
		 _BGTex ("BG", 2D) = "white" {}
		 _FGTex ("FG", 2D) = "white" {}
		 _BG2Tex ("BG2", 2D) = "white" {}
		 _FG2Tex ("FG2", 2D) = "white" {}
		_CloudTex ("Clouds", 2D) = "white" {}
		_SunTex ("Sun", 2D) = "white" {}
		[MaterialToggle] PixelSnap ("Pixel snap", Float) = 0
		_energy ("Energy", float) = 0
		_stage ("Stage", float) = 0
		_sunPos1 ("SunPos1", Vector) = (0,0,0,0)
		_sunPos2 ("SunPos2", Vector) = (0,0,0,0)
		_sunSize ("SunSize", float) = 5
		bgbgCloud ("Backmost Clouds", Color) = (0.87843137254901960784313725490196, 0.94901960784313725490196078431373, 0.93725490196078431372549019607843, 1)
		bgCloud ("Back Clouds", Color) = (1, 1, 1, 1)
		fgCloud ("Front Clouds", Color) = (1, 1, 1, 1)
		bgbgCloud2 ("Backmost Clouds 2", Color) = (0.93725490196078431372549019607843, 0.94901960784313725490196078431373, 0.87843137254901960784313725490196, 1)
		bgCloud2 ("Back Clouds 2", Color) = (1, 1, 1, 1)
		fgCloud2 ("Front Clouds 2", Color) = (1, 1, 1, 1)
	}

	SubShader
	{
		Tags
		{ 
			"Queue"="Transparent" 
			"IgnoreProjector"="True" 
			"RenderType"="Transparent" 
			"PreviewType"="Plane"
		//	"CanUseSpriteAtlas"="True"
		}

		Cull Off
		Lighting Off
		ZWrite Off
		Blend One OneMinusSrcAlpha

		Pass
		{
		CGPROGRAM
			#pragma vertex vert
			#pragma fragment frag
			#pragma multi_compile _ PIXELSNAP_ON
			#include "UnityCG.cginc"
			
			struct appdata_t
			{
				float4 vertex   : POSITION;
				float2 texcoord : TEXCOORD0;
			};

			struct v2f
			{
				float4 vertex   : SV_POSITION;
				float2 texcoord  : TEXCOORD0;
			//	float2 texcoord2 : TEXCOORD1;
			};

			v2f vert(appdata_t IN)
			{
				v2f OUT;
				OUT.vertex = mul(UNITY_MATRIX_MVP, IN.vertex);
				OUT.texcoord = IN.texcoord;
				#ifdef PIXELSNAP_ON
				OUT.vertex = UnityPixelSnap (OUT.vertex);
				#endif

//				OUT.vertex.x += OUT.vertex.x * saturate(cos(_Time.w*3) * 0.1 * saturate(OUT.vertex.y*0.5+0.5-0.3));

				return OUT;
			}
			
			sampler2D _BGTex;
			sampler2D _FGTex;
			sampler2D _MainTex;
			sampler2D _BG2Tex;
			sampler2D _FG2Tex;
			sampler2D _Main2Tex;
			sampler2D _CloudTex;
			sampler2D _SunTex;
			float _AlphaSplitEnabled;
			float _energy;
			float _stage;
			float2 _sunPos1;
			float2 _sunPos2;
			float _sunSize;
			
			float4 bgbgCloud = float4( float3(224, 242, 239)/255, 1 );
			float4 bgCloud = float4( 1, 1, 1, 1 );
			float4 fgCloud = float4( 1, 1, 1, 1 );
			float4 bgbgCloud2;
			float4 bgCloud2 = float4( 1, 1, 1, 1 );
			float4 fgCloud2 = float4( 1, 1, 1, 1 );

			fixed4 frag(v2f IN) : SV_Target
			{
				
			//	float testDuration = 1.0/16;
			//	float pulses = 4;
			//	float pulseSize = 0.01;
			//	float energy = saturate(frac(_Time.y*-testDuration)*1.2-0.1);
			//	energy = saturate( energy + saturate(sin(energy*2*3.14159*pulses))*pulseSize );
			//	energy = 1-energy;

				float energy = _energy;

				float energy1 = saturate((energy - 0.6)/0.4);
				float energy2 = saturate((energy - 0.4)/0.6);
				float energy3 = saturate((energy - 0.0)/0.9);
				
				float2 sunPos = lerp( _sunPos1, _sunPos2, saturate(_stage) );
				float2 sunUV = IN.texcoord;
				sunUV.y = 1-sunUV.y;
				sunUV = sunUV * float2(1920, 579) / 1920;
				sunUV -= sunPos;
				sunUV *= _sunSize;
			//	sunUV.y += _stage;
				fixed4 sun = tex2D (_SunTex, sunUV);

				float2 fgUV = IN.texcoord;
				float2 bgUV = IN.texcoord;
				fgUV.x += sin(_Time.y)*0.01 * fgUV.y;
				bgUV.x += cos(_Time.y)*0.01 * bgUV.y;

				fgUV.y = fgUV.y + smoothstep( 0, 1, 0.5-energy3 );
				bgUV.y = bgUV.y + smoothstep( 0, 1, 0.3-energy2 );
				
				fixed4 color = tex2D (_MainTex, IN.texcoord);
				fixed4 bg = tex2D (_BGTex, bgUV);
				fixed4 fg = tex2D (_FGTex, fgUV);
				fixed4 color2 = tex2D (_Main2Tex, IN.texcoord);
				fixed4 bg2 = tex2D (_BG2Tex, bgUV);
				fixed4 fg2 = tex2D (_FG2Tex, fgUV);
				fixed4 cloud = float4(0,0,0,0);
				cloud.r = tex2D (_CloudTex, frac(IN.texcoord + float2(1,0) * _Time.y*0.01)).r;
				cloud.g = tex2D (_CloudTex, frac(IN.texcoord + float2(1,0) * _Time.y*0.02)).g;
				cloud.b = tex2D (_CloudTex, frac(IN.texcoord + float2(1,0) * _Time.y*0.03)).b;

				float stage = saturate(_stage);
				bg = lerp( bg, bg2, stage );
				fg = lerp( fg, fg2, stage );
				color = lerp( color, color2, stage );
				

				fixed cd  = dot(color.rgb, 1/3.0);

				color.rgb = lerp( color.rgb, sun.rgb, sun.a );

				color = lerp( color, bgbgCloud, cloud.r );
				bg = lerp( bg, bgCloud, cloud.g );
				fg = lerp( fg, fgCloud, cloud.b );
				
				fixed bgd = dot(bg.rgb, 1/3.0);
				fixed fgd = dot(fg.rgb, 1/3.0);

				color.rgb = lerp( cd.xxx, color.rgb, energy1 );
				bg.rgb = lerp( bgd.xxx, bg.rgb, energy2 );
				bg.rgb = lerp(  cd.xxx, bg.rgb, energy2 );
				fg.rgb = lerp( fgd.xxx, fg.rgb, energy3 );
				fg.rgb = lerp(  cd.xxx, fg.rgb, energy3 );

				color.rgb = lerp( color.rgb, bg.rgb, bg.a );
				color.rgb = lerp( color.rgb, fg.rgb, fg.a );
				
				return color;
			}
		ENDCG
		}
	}
}
